#include "Listen.h"
#include <unordered_map>

std::unordered_map <std::string, std::unique_ptr<BaseCallBack>> g_baseCallBackMap;
std::mutex g_baseCallBackMapMutex;

void NewBaseCallBack(std::string opid,
                     std::shared_ptr <flutter::MethodResult<flutter::EncodableValue>> result) {
    std::lock_guard <std::mutex> lock(g_baseCallBackMapMutex);
    g_baseCallBackMap[opid] = std::make_unique<BaseCallBack>(result);
}

void CallBaseCallBack(char *opid, int errCode, char *errMsg, char *msg) {
    std::lock_guard <std::mutex> lock(g_baseCallBackMapMutex);
    auto it = g_baseCallBackMap.find(std::string(opid));
    if (it != g_baseCallBackMap.end()) {
        auto ctx = std::move(it->second);  //unique_ptr
        ctx->HandleCallback(opid, errCode, errMsg, msg);
    }
}