#ifndef LISTEN_H
#define LISTEN_H

#include <libopenimsdk.h>
#include "flutter/encodable_value.h"
#include "flutter/method_result.h"



class BaseCallBack {
public:
	BaseCallBack(std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result) {
		this->result = result;
	}

	std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result = nullptr;

	void HandleCallback(char* opid, int errCode, char* errMsg, char* msg) {
		if (result == nullptr) {
			return;
		}

		if (errCode == 0) {
			result->Success(flutter::EncodableValue(std::string(msg)));
		}
		else {
			result->Error(std::to_string(errCode), std::string(errMsg), flutter::EncodableValue(std::string(msg)));
		}
	}
};

// 全局映射表
extern std::unordered_map<std::string, std::unique_ptr<BaseCallBack>> g_baseCallBackMap;
extern std::mutex g_baseCallBackMapMutex;


void NewBaseCallBack(std::string opid, std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
void CallBaseCallBack(char* opid, int errCode, char* errMsg, char* msg);



//todo 没想好怎么实现
class uploadFileCallBack {
public:
    uploadFileCallBack(std::string id) {
        this->id = id;
    }

    std::string id = "";

    void HandleCallback(char* opid, int errCode, char* errMsg, char* msg) {


    }
};


#endif